var currency = require("./currency.js");

module.exports = {
    dy: {
        /**
         *    搜索栏跳转
         * @param {*} c    要跳转的参数 
         */
        sdkSearch: function (c) {
            app.startActivity({
                action: "android.intent.action.VIEW",
                data: "snssdk1128://search/?keyword=" + c,
                packageName: "com.ss.android.ugc.aweme",
            });
            sleep(random(6000, 8000));
        },

        /**
         *    返回首页
         */
        sdkHome: function () {
            app.startActivity({
                action: "android.intent.action.MAIN",
                packageName: "com.ss.android.ugc.aweme",
                className: "com.ss.android.ugc.aweme.splash.SplashActivity",
                category: ["android.intent.category.LAUNCHER"],
                flags: ["activity_new_task"]
            });
            sleep(random(3000, 5000));
        },

        /**
         *   概率点击
         * @param {*} c    概率
         * @param {*} nodeinfo    id节点信息 数组
         */
        clicks: function (c, nodeinfo) {
            if (currency.chance(c)) {
                for (let i = 0; i <= nodeinfo.length; i++) {
                    currency.nodeClick(nodeinfo[i], "i", 1, [3000, 5000]);
                }
            }
        },

        /**
         * 获取粉丝数
         * @param {*} nodeinfo 
         */
        getFans: function (nodeinfo) {
            let node;
            let content;
            node = id(nodeinfo).visibleToUser().findOnce();
            if (node) {
                content = node.text();
                if (content.indexOf("w") >= 0) {
                    content = parseFloat(content);
                    content = content * 10000;
                    content = parseInt(content);
                }
                return content;
            } else {
                return 0;
            }
        },

        /**
         * 发私信
         * @param {*} c    概率
         * @param {*} moreNodeinfo   节点 更多
         * @param {*} arrivedinfo   节点 已发送的历史消息
         * @param {*} moreNodeinfo   企业号店铺客服识别节点框
         * @param {*} inputNodeinfo    节点 输入框
         * @param {*} messages        话术
         * @param {*} sendNodeinfo  节点  发送
         * @param {*} backNodeinfo    节点  返回
         */
        privateLetter: function (c, moreNodeinfo, arrivedinfo, enterpriseNodeinfo, inputNodeinfo, messages, sendNodeinfo, backNodeinfo) {
            if (currency.chance(c)) {
                currency.nodeClick(moreNodeinfo, "i", 1, [3000, 3200]);
                currency.nodeClick("发私信", "t", 2, [3000, 3200]);
                currency.nodeClick("发私信", "d", 1, [3000, 3200]);
                currency.nodeClick("聊天", "t", 2, [3000, 3200]);
                currency.nodeClick("发消息", "t", 2, [3000, 3200]);
                currency.nodeClick("发消息", "d", 2, [3000, 3200]);
                currency.nodeClick("私聊", "t", 2, [3000, 3200]);

                let arrived = id(arrivedinfo).visibleToUser().findOnce();
                if (arrived == null) {
                    let node1 = id(enterpriseNodeinfo).visibleToUser().findOnce();
                    if (node1) {
                        let node2 = node1.child(0);
                        if (node2) {
                            click(node2.bounds().centerX(), node2.bounds().centerY());
                            sleep(random(2000, 3000));
                        }
                    }
                    let message = currency.randomWords(messages);
                    for (let i = 0; i < message.length; i++) {
                        currency.nodeClick(inputNodeinfo, "i", 1, [3000, 5000]);
                        setText(message[i]);
                        sleep(random(2500, 3000));
                        currency.nodeClick(sendNodeinfo, "i", 1, [3000, 5000]);
                    }
                } else {
                    toastLog("存在历史消息跳过私信");
                }

                currency.nodeClick(backNodeinfo, "i", 1, [3000, 5000]);
            }
        },

        /**
         * 发评论
         * @param {*} c    概率
         * @param {*} discussNodeinfo   节点 评论
         * @param {*} inputNodeinfo    节点 输入框
         * @param {*} messages        话术
         * @param {*} sendNodeinfo  节点  发送
         * @param {*} backNodeinfo    节点  返回
         */
        comment: function (c, discussNodeinfo, inputNodeinfo, messages, sendNodeinfo, backNodeinfo) {
            if (currency.chance(c)) {
                currency.nodeClick(discussNodeinfo, "i", 1, [3000, 5000]);
                currency.nodeClick(inputNodeinfo, "i", 1, [3000, 5000]);
                if (messages) {
                    let message = currency.randomWords(messages);
                    for (let i = 0; i <= message.length; i++) {
                        setText(message[i]);
                        sleep(random(2500, 3000));
                        currency.nodeClick(sendNodeinfo, "i", 1, [3000, 5000]);
                    }
                }
                currency.nodeClick(backNodeinfo, "i", 1, [3000, 5000]);
            }
        },

        /**
         * 评论后的点赞
         * @param {*} c    概率
         * @param {*} discussNodeinfo    节点  评论  
         * @param {*} likesNodeinfo    节点   评论后的点赞
         * @param {*} backNodeinfo    节点  关闭评论框
         */
        commentClick: function (c, discussNodeinfo, likesNodeinfo, backNodeinfo) {
            if (currency.chance(c)) {
                currency.nodeClick(discussNodeinfo, "i", 1, [3000, 5000]);
                let like = id(likesNodeinfo).visibleToUser().find();
                if (like) {
                    for (let i = 0; i <= like.length; i++) {
                        like[i].click();
                        sleep(random(800, 1300));
                    }
                }
                currency.nodeClick(backNodeinfo, "i", 1, [3000, 5000]);
            }
        },

        /**
         * 直播中或者广告跳过
         * @param {*} liveNodeinfo      节点  直播中
         * @param {*} ertisingNodeinfo    节点  广告
         */
        studioSkip: function (liveNodeinfo, ertisingNodeinfo) {
            while (id(liveNodeinfo).visibleToUser().findOnce() || textContains("点击进入").visibleToUser().findOnce() || id(ertisingNodeinfo).visibleToUser().findOnce()) {
                currency.fullSlide();
            }
        },

        /**
         * 点赞
         */
        praise: function () {
            click(device.width * 0.5, device.height * 0.4);
            sleep(100);
            click(device.width * 0.5, device.height * 0.4);
            sleep(80);
            click(device.width * 0.5, device.height * 0.4);
            sleep(100);
            click(device.width * 0.5, device.height * 0.4);
            sleep(80);
            click(device.width * 0.5, device.height * 0.4);
            sleep(2000);
        },
        /**
         * 个人主页检查三连
         * @param {*} fans 范围数组
         * @param {*} product 要满足的作品数
         * @param {*} personal 私密账号检查开关
         * @param {*} personalnode 私密账号节点信息
         */
        trinity: function (fans, product, personal, fansnode, fansnode_new, personalnode) {
            let result = true;
            let fansnum = currency.getFans(fansnode);
            if (fansnum == 0) {
                fansnum = currency.getFans(fansnode_new)
            }
            log('fansnum---' + fansnum);
            if (!((fansnum >= parseFloat(fans[0])) && (fansnum <= parseFloat(fans[1])))) {
                toastLog("粉丝数不满足条件");
                result = false;
            }

            let productNumNode = textContains("作品").findOne(5000);
            let productNum;
            if (productNumNode) {
                productNum = productNumNode.text().replace(/[^0-9]/ig, "");
                productNum = parseInt(productNum);
                log("作品数:" + productNum);
                if (product > productNum) {
                    toastLog("作品数量不满足条件");
                    result = false;
                }
            }

            if (personal) {
                if (currency.nodeExists(personalnode, "i")) {
                    toastLog("跳过私密账号");
                    result = false;
                }
            }
            return result;
        },
        /**
         * 获取睡眠时间区间
         * @param {*} speed 速度
         * @returns 
         */
        getSleepRange: function () {
            let availMem = (device.getAvailMem()/(1024*1024*1024)).toFixed(1);
            var sleeprange = [2000, 3000, 4000 , 4500];
            if (currency.isRangeIn(availMem, 0.1, 0.3)) {
                toastLog("当前剩余运行内存很低，运行速度将自动调为缓慢");
                sleeprange = [10000, 11000, 12000 , 15000];
            }else if (currency.isRangeIn(availMem, 0.4, 0.8)) {
                 sleeprange = [3000, 3500, 4000 , 4500];
             }else if (currency.isRangeIn(availMem, 0.9, 1.1)) {
                sleeprange = [2000, 2500, 3000 , 4000];
            } else if (currency.isRangeIn(availMem, 1.2, 1.7)) {
                sleeprange = [1500, 2000, 3000, 3500];
            } else if (currency.isRangeIn(availMem, 1.8, 2.5)) {
                sleeprange = [1000, 2000, 3000, 4000];
            } else if (currency.isRangeIn(availMem, 2.6, 3.1)) {
                sleeprange = [900, 1800, 2200, 3000];
            } else if (currency.isRangeIn(availMem, 3.2, 18)) {
                sleeprange = [500, 1500, 2000, 2500];
            }

            return sleeprange;
        },
        /**
         * 主页多重检查
         * @param {*} fans 粉丝条件数组
         * @param {*} didarr 已操作过的用户名数组
         * @param {*} namenode 主页用户名节点
         * @param {*} product 作品数量节点
         * @param {*} personal 是否识别私密账号
         * @param {*} fansnode 粉丝数量节点
         * @param {*} fansnode_new 新界面粉丝数量节点
         * @param {*} personalnode 私密账号节点
         * @returns 
         */
        multiCensor: function (fans, didarr, namenode, product, personal, fansnode, fansnode_new, personalnode) {
            let result = true;

            let username = currency.getContent(namenode, 't');
            toastLog(username);
            if (username != "") {
                if (didarr.indexOf(username) != -1) {
                    toastLog("该用户已操作过");
                    result = false;
                } else {
                    didarr.push(username);
                }
            }


            let fansnum = currency.getFans(fansnode);
            if (fansnum == 0) {
                fansnum = currency.getFans(fansnode_new)
            }
            log('fansnum---' + fansnum);
            if (!((fansnum >= parseFloat(fans[0])) && (fansnum <= parseFloat(fans[1])))) {
                toastLog("粉丝数不满足条件");
                result = false;
            }

            let productNumNode = textContains("作品").findOne(5000);
            let productNum;
            if (productNumNode) {
                productNum = productNumNode.text().replace(/[^0-9]/ig, "");
                productNum = parseInt(productNum);
                log("作品数:" + productNum);
                if (product > productNum) {
                    toastLog("作品数量不满足条件");
                    result = false;
                }
            }

            if (personal) {
                if (currency.nodeExists(personalnode, "i")) {
                    toastLog("跳过私密账号");
                    result = false;
                }
            }
            return result;
        }
    }
}